## pinfish 0.1.0%2Bds

=== cluster_gff/Makefile ===
all: build

.PHONY: ct com push fetch gt fmt fix

TOOLS=../tools

# Utility targets:
ct:
	git log --graph
fmt: *.go
	go fmt *.go
com: fmt
	git commit -a
push:
	git push --all
fetch:
	git fetch --all
fix:
	go fix .

# Target:
BINARY=cluster_gff

# These are the values we want to pass for VERSION and BUILD
VERSION=0.1.0
BUILD=`git rev-parse HEAD`

# Setup the -ldflags option for go build here, interpolate the variable values
LDFLAGS=-ldflags "-X main.Version=${VERSION} -X main.Build=${BUILD}"

# Builds the project
build: *.go
	go build ${LDFLAGS} -o ${BINARY}

# Installs our project: copies binaries
install:
	go install ${LDFLAGS}

# Cleans our project: deletes binaries
clean:
	if [ -f ${BINARY} ] ; then rm ${BINARY} ; fi

# Test tool on GFF generated from simulated data (with sequencing errors) aligned using minimap2:
test_sim:
	 ./cluster_gff -a ./test_data/cls_sirv_sim_mm2.tab -c 100  ./test_data/sirv_simulated_mm2.gff > ./test_data/cls_sirv_sim_mm2.gff
	 (cd test_data; gffcompare -r SIRV_C_150601a.gtf cls_sirv_sim_mm2.gff)
	 cat ./test_data/gffcmp.stats

# Test tool on GFF generated from SIRV E0 mix full lenegth cDNA dataset:
test_sirv:
	 ./cluster_gff -a ./test_data/sirv_e0.tab -c 10 ./test_data/sirv_e0_sorted.gff > ./test_data/cls_sirv_e0_sorted.gff
	 (cd test_data; gffcompare -r SIRV_C_150601a.gtf cls_sirv_e0_sorted.gff)
	 cat ./test_data/gffcmp.stats

# Run tool on small example GFF:
test_small:
	 ./cluster_gff -a test_data/rs_clusters.tab -c 1 test_data/real_small.gff

=== debian/changelog ===
pinfish (0.1.0+ds-4) unstable; urgency=medium

  * Team upload.
  * Cleanup bam files from dh_auto_test
    Closes: #1048260
  * Standards-Version: 4.6.2 (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * No tab in license text (routine-update)
  Add missing ${misc:Built-Using} to Built-Using on pinfish.
  Apply multi-arch hints.

   + pinfish-examples: Add Multi-Arch: foreign.


 -- Andreas Tille <tille@debian.org>  Fri, 12 Jan 2024 07:23:48 +0100

pinfish (0.1.0+ds-3) unstable; urgency=medium

  * Declare compliance with policy 4.5.1
  * Remove d/gitlab-ci.yml, add d/salsa-ci.yml
  * d/p/do-not-overflow-int.patch: Declare minlen as
    per arch that we are building on to avoid
    integer overflow

 -- Nilesh Patra <nilesh@debian.org>  Tue, 17 Aug 2021 21:33:10 +0530

pinfish (0.1.0+ds-2) unstable; urgency=medium

  * Limit testing to amd64 and arm64 for now
  * Source-only-upload for testing migration

 -- Nilesh Patra <npatra974@gmail.com>  Tue, 10 Nov 2020 14:51:27 +0530

pinfish (0.1.0+ds-1) unstable; urgency=medium

  * Initial release (Closes: #970447)

 -- Nilesh Patra <npatra974@gmail.com>  Wed, 16 Sep 2020 12:36:21 +0530

## pinfish 0.1.0+ds

=== collapse_partials/Makefile ===
all: build

.PHONY: ct com push fetch gt fmt fix

TOOLS=../tools

# Utility targets:
ct:
	git log --graph
fmt: *.go
	go fmt *.go
com: fmt
	git commit -a
push:
	git push --all
fetch:
	git fetch --all
fix:
	go fix .

# Target:
BINARY=collapse_partials

# These are the values we want to pass for VERSION and BUILD
VERSION=0.1.0
BUILD=`git rev-parse HEAD`

# Setup the -ldflags option for go build here, interpolate the variable values
LDFLAGS=-ldflags "-X main.Version=${VERSION} -X main.Build=${BUILD}"

# Builds the project
build: *.go
	go build ${LDFLAGS} -o ${BINARY}

# Installs our project: copies binaries
install:
	go install ${LDFLAGS}

# Cleans our project: deletes binaries
clean:
	if [ -f ${BINARY} ] ; then rm ${BINARY} ; fi

# Run tool on a small test case:
test_small:
	./collapse_partials  test_data/small_test.gff

=== polish_clusters/Makefile ===
all: build

.PHONY: ct com push fetch gt fmt fix

TOOLS=../tools

# Utility targets:
ct:
	git log --graph
fmt: *.go
	go fmt *.go
com: fmt
	git commit -a
push:
	git push --all
fetch:
	git fetch --all
fix:
	go fix .

# Target:
BINARY=polish_clusters

# These are the values we want to pass for VERSION and BUILD
VERSION=0.1.0
BUILD=`git rev-parse HEAD`

# Setup the -ldflags option for go build here, interpolate the variable values
LDFLAGS=-ldflags "-X main.Version=${VERSION} -X main.Build=${BUILD}"

# Builds the project
build: *.go
	go build ${LDFLAGS} -o ${BINARY}

# Installs our project: copies binaries
install:
	go install ${LDFLAGS}

# Cleans our project: deletes binaries
clean:
	if [ -f ${BINARY} ] ; then rm ${BINARY} ; fi

# Test tool on simulated dataset (with sequencing errors):
test_sim:
	 ./polish_clusters -t 40 -c 100 -o test_data/cons.fas -a test_data/cls_sirv_sim_mm2.tab ../spliced_bam2gff/test_data/sirv_simulated.bam
	 (cd test_data; minimap2 -ax splice --splice-flank=no SIRV_150601a.fasta cons.fas | samtools view -Sb -F 2304 | samtools sort - -o test_sorted.bam)
	 (cd test_data; ../../spliced_bam2gff/spliced_bam2gff -M test_sorted.bam > test_pol.gff;gffcompare -r SIRV_C_150601a.gtf test_pol.gff)
	 cat test_data/gffcmp.stats

# Test tool on SIRV E0 full length cDNA dataset (may take a while):
test_sirv:
	 ./polish_clusters -t 40 -c 50 -o test_data/sirv_cons.fas -a test_data/sirv_e0.tab test_data/sirv_e0_sorted.bam
	 (cd test_data; minimap2 -ax splice --splice-flank=no SIRV_150601a.fasta sirv_cons.fas | samtools view -Sb -F 2304 | samtools sort - -o test_sorted.bam)
	 (cd test_data; ../../spliced_bam2gff/spliced_bam2gff -M test_sorted.bam > test_pol.gff;gffcompare -r SIRV_C_150601a.gtf test_pol.gff)
	 cat test_data/gffcmp.stats

=== spliced_bam2gff/Makefile ===
all: build

.PHONY: ct com push fetch gt fmt fix

TOOLS=../tools

# Utility targets:
ct:
	git log --graph
fmt: *.go
	go fmt *.go
com: fmt
	git commit -a
push:
	git push --all
fetch:
	git fetch --all
fix:
	go fix .

# Target:
BINARY=spliced_bam2gff

# These are the values we want to pass for VERSION and BUILD
VERSION=0.1.0
BUILD=`git rev-parse HEAD`

# Setup the -ldflags option for go build here, interpolate the variable values
LDFLAGS=-ldflags "-X main.Version=${VERSION} -X main.Build=${BUILD}"

# Builds the project
build: *.go
	go build ${LDFLAGS} -o ${BINARY}

# Installs our project: copies binaries
install:
	go install ${LDFLAGS}

# Cleans our project: deletes binaries
clean:
	if [ -f ${BINARY} ] ; then rm ${BINARY} ; fi

# Test tool on simulated data (with no sequencing errors) agains the GFF output generated by GMAP:
test:
	 ./spliced_bam2gff -g ./test_data/sirv_no_errors_gmap.bam > ./test_data/test_out.gff
	 (cd test_data; gffcompare -V -r sirv_no_errors_gmap.gff test_out.gff)
	 cat ./test_data/gffcmp.stats

# Test tool on simulated data (with sequencing errors) agains the GFF output generated by GMAP:
test_err:
	 ./spliced_bam2gff  -g ./test_data/sirv_errors_gmap.bam > ./test_data/test_out_err.gff
	 (cd test_data; gffcompare -V -r sirv_errors_gmap.gff test_out_err.gff)
	 cat ./test_data/gffcmp.stats

# Run tool on larger simulated data (with sequencing errors):
test_sim:
	./spliced_bam2gff -M -s ./test_data/sirv_simulated.bam > ./test_data/sirv_simulated_mm2.gff

# Run tool on SIRV E0 mix full length cDNA dataset aligned using minimap2:
test_sirv:
	./spliced_bam2gff -M -s ../polish_clusters/test_data/sirv_e0_sorted.bam > /dev/null

=== debian/changelog ===
pinfish (0.1.0+ds-4ubuntu0.24.04.3) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Wed, 25 Jun 2025 17:25:14 +1000

pinfish (0.1.0+ds-4ubuntu0.24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Thu, 07 Nov 2024 12:46:00 +1000

pinfish (0.1.0+ds-4ubuntu0.24.04.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.21 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 16 Jul 2024 08:30:48 +0530

=== debian/control ===
Source: pinfish
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Nilesh Patra <nilesh@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-biogo-biogo-dev,
               golang-github-biogo-hts-dev,
               golang-github-google-uuid-dev,
               samtools,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/pinfish
Vcs-Git: https://salsa.debian.org/med-team/pinfish.git
Homepage: https://github.com/nanoporetech/pinfish
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/nanoporetech/pinfish

Package: pinfish
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         minimap2,
         racon
Built-Using: ${misc:Built-Using}
Description: Collection of tools to annotate genomes using long read transcriptomics data
 The toolchain is composed of the following tools:
 1. spliced_bam2gff - a tool for converting sorted BAM
 files containing spliced alignments
 into GFF2 format. Each read will be represented as a distinct
 transcript. This tool comes handy when visualizing spliced
 reads at particular loci and to provide input to the rest
 of the toolchain.
 .
 2. cluster_gff - this tool takes a sorted GFF2 file as
 input and clusters together reads having similar
 exon/intron structure and creates a rough consensus
 of the clusters by taking the median of exon
 boundaries from all transcripts in the cluster.
 .
 3. polish_clusters - this tool takes the cluster
 definitions generated by cluster_gff and for each
 cluster creates an error corrected read by mapping
 all reads on the read with the median length
 and polishing it using racon. The polished reads
 can be mapped to the genome using minimap2 or GMAP.
 .
 4. collapse_partials - this tool takes GFFs generated
 by either cluster_gff or polish_clusters and filters
 out transcripts which are likely to be based on RNA
 degradation products from the 5' end. The tool clusters
 the input transcripts into "loci" by the 3' ends and
 discards transcripts which have a compatible transcripts
 in the loci with more exons.

Package: pinfish-examples
Architecture: all
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: foreign
Description: Examples and test data for pinfish
 The toolchain is composed of the following tools:
 1. spliced_bam2gff - a tool for converting sorted BAM
 files containing spliced alignments
 into GFF2 format. Each read will be represented as a distinct
 transcript. This tool comes handy when visualizing spliced
 reads at particular loci and to provide input to the rest
 of the toolchain.
 .
 2. cluster_gff - this tool takes a sorted GFF2 file as
 input and clusters together reads having similar
 exon/intron structure and creates a rough consensus
 of the clusters by taking the median of exon
 boundaries from all transcripts in the cluster.
 .
 3. polish_clusters - this tool takes the cluster
 definitions generated by cluster_gff and for each
 cluster creates an error corrected read by mapping
 all reads on the read with the median length
 and polishing it using racon. The polished reads
 can be mapped to the genome using minimap2 or GMAP.
 .
 4. collapse_partials - this tool takes GFFs generated
 by either cluster_gff or polish_clusters and filters
 out transcripts which are likely to be based on RNA
 degradation products from the 5' end. The tool clusters
 the input transcripts into "loci" by the 3' ends and
 discards transcripts which have a compatible transcripts
 in the loci with more exons.
 .
 This package contains a test data set as well as sample scripts
 running some test suite provided by Debian also as autopkgtest.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.bam" -delete

override_dh_auto_test:
	dh_auto_test
	cat debian-tests-data/sirv_e0_sorted.sam| samtools view -Sb - > polish_clusters/test_data/sirv_e0_sorted.bam
	cat debian-tests-data/sirv_errors_gmap.sam| samtools view -Sb - > spliced_bam2gff/test_data/sirv_errors_gmap.bam
	cat debian-tests-data/sirv_no_errors_gmap.sam| samtools view -Sb - > spliced_bam2gff/test_data/sirv_no_errors_gmap.bam
	cat debian-tests-data/sirv_simulated.sam| samtools view -Sb - > spliced_bam2gff/test_data/sirv_simulated.bam

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
version=4
opts="repacksuffix=+ds,dversionmangle=auto,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pinfish-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/nanoporetech/pinfish/tags .*/v?(\d\S*)\.tar\.gz debian
